#!/bin/bash

function __makedirectory1() {

    dn=$1

    if [ ! -e $dn ]; then
	mkdir $dn
	chmod a+rwx $dn
    elif [ ! -d $dn ]; then
	echo 'error: "'$dn'" exists but it is not directory.'
	echo 'You must remove it and make directory "'$dn'".'
	while true
	  do
	  read -p 'remove "'$dn'" ? [yes or no] >' answer
	  case $answer in
	      yes )
		  rm -f $dn
		  mkdir $dn
		  chmod a+rwx $dn
		  break;
		  ;;
	      no )
		  echo 'quit.'
		  exit 0
		  ;;
	      * )
		  echo 'Please input yes or no.'
		  ;;
	  esac
	done
    elif [ ! -r $dn ] || [ ! -w $dn ] || [ ! -r $dn ]; then
	echo 'error. Please append permission "rwx" to "'$dn'".'
	exit 1
    fi
    return 0
}

function __changeexectable1() {
    filename=$1
    if [ -e $filename ] && [ -f $filename ]; then
	chmod a+x $filename
    else
	echo 'error: "'$filename'" not exist'
	exit 2
    fi
    return 0
}
function __changeexectable2() {
    filename=$1
    if [ -e $filename ] && [ -f $filename ]; then
	chmod a+x $filename
    else
	echo 'warning: "'$filename'" not exist.'
    fi
    return 0
}
function __changereadable1() {
    filename=$1
    if [ -e $filename ] && [ -f $filename ]; then
	chmod a+r $filename
    else
	echo 'error: "'$filename'" not exist.'
	exit 3
    fi
    return 0
}


while true
  do
  read -p 'You try to start installation. OK ? [yes or no] >' answer
  case $answer in
      yes )
	  break;
	  ;;
      no )
	  echo 'quit.'
	  exit 0
	  ;;
      * )
	  echo 'Please input yes or no.'
	  ;;
  esac
done

echo 'creating directory "tmp" ...'
__makedirectory1 "tmp"
echo 'creating directory "log" ...'
__makedirectory1 "log"

echo 'making "boot" executable ...'
__changeexectable1 "boot"

echo 'making "itp14_demo" executable ...'
__changeexectable1 "itp14_demo"
echo 'making "itp50_demo" executable ...'
__changeexectable1 "itp50_demo"

echo 'making "itp14" executable ...'
__changeexectable2 "itp14"
echo 'making "itp50" executable ...'
__changeexectable2 "itp50"

echo 'making "parser.dat" readable ...'
__changereadable1 "parser.dat"

echo 'making bash scripts executable ...'
chmod a+x *.bash

echo completed
