#!/bin/bash

function __makedirectory1() {

    dn=$1

    if [ ! -e $dn ]; then
	mkdir $dn
	chmod a+rwx $dn
    elif [ ! -d $dn ]; then
	echo 'エラー： "'$dn'" がありますが、ディレクトリではありません。'
	echo '"'$dn'"を削除して、同名のディレクトリを作成しないとプログラムを実行することはできません。'
	while true
	  do
	  read -p '"'$dn'を削除していいですか" ? [yes or no] >' answer
	  case $answer in
	      yes )
		  rm -f $dn
		  mkdir $dn
		  chmod a+rwx $dn
		  break;
		  ;;
	      no )
		  echo '終了'
		  exit 0
		  ;;
	      * )
		  echo 'yesかnoを入力して下さい。'
		  ;;
	  esac
	done
    elif [ ! -r $dn ] || [ ! -w $dn ] || [ ! -r $dn ]; then
	echo 'エラー。 ディレクトリ "'$dn'"のパーミッションをrwxrwxrwxにしてください。'
	exit 1
    fi
    return 0
}

function __changeexectable1() {
    filename=$1
    if [ -e $filename ] && [ -f $filename ]; then
	chmod a+x $filename
    else
	echo 'エラー： "'$filename'"がありません。'
	exit 2
    fi
    return 0
}
function __changeexectable2() {
    filename=$1
    if [ -e $filename ] && [ -f $filename ]; then
	chmod a+x $filename
    else
	echo '注意： "'$filename'"がありません。'
    fi
    return 0
}
function __changereadable1() {
    filename=$1
    if [ -e $filename ] && [ -f $filename ]; then
	chmod a+r $filename
    else
	echo 'error: "'$filename'" not exist.'
	exit 3
    fi
    return 0
}

while true
  do
  read -p '実行環境を設定します。よろしいですか? [yes or no] >' answer
  case $answer in
      yes )
	  break;
	  ;;
      no )
	  echo '終了'
	  exit 0
	  ;;
      * )
	  echo 'yesかnoを入力して下さい。'
	  ;;
  esac
done

echo 'ディレクトリ"tmp"を作成しています ...'
__makedirectory1 "tmp"
echo 'ディレクトリ"log"を作成しています ...'
__makedirectory1 "log"

echo '"boot"を実行可能ファイルにします ...'
__changeexectable1 "boot"

echo '"itp14_demo"実行可能ファイルにします ...'
__changeexectable1 "itp14_demo"
echo '"itp50_demo"実行可能ファイルにします ...'
__changeexectable1 "itp50_demo"

echo '"itp14"実行可能ファイルにします ...'
__changeexectable2 "itp14"
echo '"itp50"実行可能ファイルにします ...'
__changeexectable2 "itp50"

echo '"parser.dat"を読込可能にします ...'
__changereadable1 "parser.dat"

echo 'bashスクリプトを実行可能ファイルにします ...'
chmod a+x *.bash

echo '終りました。'
